Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1355592 - Review Request: libvmi - A library for performing virtual-machine introspection
Summary: Review Request: libvmi - A library for performing virtual-machine introspection
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Matthew Garrett
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-07-12 02:46 UTC by W. Michael Petullo
Modified: 2016-11-03 23:54 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-10-31 07:36:25 UTC
mjg59: fedora-review+


Attachments (Terms of Use)

Description W. Michael Petullo 2016-07-12 02:46:55 UTC
Spec URL: https://www.flyn.org/SRPMS/libvmi.spec
SRPM URL: https://www.flyn.org/SRPMS/libvmi-0.10.1-1.fc24.src.rpm

Description:
LibVMI is a C library with Python bindings that makes it easy to monitor
the low-level details of a running virtual machine by viewing its memory,
trapping on hardware events, and accessing the vCPU registers.

Fedora Account System Username: mikep

Comment 1 Igor Gnatenko 2016-07-12 06:52:43 UTC
> Source0:        %{name}-%{version}.tar.gz
Must be full URL, something like: https://github.com/libvmi/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz

> BuildRequires:  glib2-devel >= 2.16 check-devel >= 0.9.4
BuildRequires: pkgconfig(glib-2.0)
BuildRequires: pkgconfig(check)

> rm -rf $RPM_BUILD_ROOT
not needed

> find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'
find %{buildroot}%{_libdir} -name '*.la' -delete -print

> rm -f ${RPM_BUILD_ROOT}/%{_bindir}/*
rm -vf %{buildroot}{_bindir}/*

> # Parallel make fails.
there should be link to upstream issue

> %{_includedir}/libvmi
%{_includedir}/%{name}/

> BuildRequires:  bison flex xen-devel fuse-devel
also guessing there are missing BuildRequires: autoconf automake libtool
or something like to for ./autogen.sh

* Missing BuildRequires: gcc


Once this will be fixed, I will do full review.

Comment 2 Igor Gnatenko 2016-07-12 06:55:57 UTC
* about examples: I guess you can disable them by using --enable-examples=
* I would recommend explicitly enable kvm, xen support by: --enable-kvm=, -enable-xen= and probably some others (https://github.com/libvmi/libvmi/blob/master/configure.ac#L507)

Comment 3 W. Michael Petullo 2016-07-13 00:22:45 UTC
I just published a new libvmi.spec which addresses the comments in #1. I now explicitly enable the features which build on Fedora. The released version does not yet support --disable-examples, so I still remove the example binaries after building.

Spec URL: https://www.flyn.org/SRPMS/libvmi.spec
SRPM URL: https://www.flyn.org/SRPMS/libvmi-0.10.1-1.fc24.src.rpm

Comment 4 W. Michael Petullo 2016-07-29 23:41:20 UTC
Update to Git version, which seems to fix a number of bugs.

Spec URL: https://www.flyn.org/SRPMS/libvmi.spec
SRPM URL: https://www.flyn.org/SRPMS/libvmi-0.11.0-1.20160726gitbb33c14.fc24.src.rpm

Comment 5 W. Michael Petullo 2016-10-05 15:27:05 UTC
Update to newer Git version.

Spec URL: https://www.flyn.org/SRPMS/libvmi.spec
SRPM URL: https://www.flyn.org/SRPMS/libvmi-0.11.0-1.20161003git5ad492c.fc24.src.rpm

Comment 6 Matthew Garrett 2016-10-15 23:39:24 UTC
Broadly speaking, this seems fine, but one significant issue: the library package is shipping libvmi-0.11.so and libvmi.so. This seems wrong. If there's an expectation that multiple versions of the libvmi development environment should be parallel-installable, we should have libvmi-0.11.so.something in the main package and libvmi-0.11.so in the -devel package. If not, we should have libvmi.so.11 (or some other versioning) in the main package and libvmi.so in the -devel package. Raw .so files should not be in the main libvmi package. This is probably something that needs to be discussed with upstream - it's easier if we solve library versioning issues there.

There's also the general concern over shared libraries calling exit(), but I think in this case it's reasonable (it's only in the safe_malloc() function).

Comment 7 W. Michael Petullo 2016-10-18 17:56:07 UTC
Move libvmi.so into -devel package. I submitted a request upstream to review the files output by the build process: https://github.com/libvmi/libvmi/issues/404.

Spec URL: https://www.flyn.org/SRPMS/libvmi.spec
SRPM URL: https://www.flyn.org/SRPMS/libvmi-0.11.0-1.20161003git5ad492c.fc24.src.rpm

Comment 8 Matthew Garrett 2016-10-18 18:16:45 UTC
Thanks - I've subscribed to the issue.

Comment 9 Matthew Garrett 2016-10-24 16:12:10 UTC
Ok, upstream made it clear that this is a deliberate choice and the argument seems reasonable. There's precedent in (a small number of) other packages we ship, so I don't think this is a blocker. Only thing - changelog version doesn't currently match the package version. Can you fix that before upload? Otherwise this is good to go - configure.ac is using an obsolete macro, but that's an upstream issue.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL (v2 or later) (with incorrect FSF address)", "MIT/X11 (BSD
     like) LGPL (v3 or later)", "LGPL (v3 or later)", "*No copyright* LGPL
     (v3 or later)", "Unknown or generated". 30 files have unknown license.
     Detailed output of licensecheck in
     /tmp/1355592-libvmi/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 102400 bytes in 15 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Scriptlets must be sane, if used.
[x]: SourceX tarball generation or download is documented.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[-]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Package should not use obsolete m4 macros
     Note: Some obsoleted macros found, see the attachment.
     See: https://fedorahosted.org/FedoraReview/wiki/AutoTools
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.

Comment 10 Gwyn Ciesla 2016-10-25 12:41:33 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/libvmi

Comment 11 Fedora Update System 2016-10-26 03:21:11 UTC
libvmi-0.11.0-1.20161003git5ad492c.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-9933858e43

Comment 12 Fedora Update System 2016-10-26 04:24:12 UTC
libvmi-0.11.0-1.20161003git5ad492c.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-65f6ca5035

Comment 13 Fedora Update System 2016-10-31 07:36:25 UTC
libvmi-0.11.0-1.20161003git5ad492c.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 14 Fedora Update System 2016-11-03 23:54:15 UTC
libvmi-0.11.0-1.20161003git5ad492c.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.